%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

THRESHOLD = 0.000025;
MAX_TAPS = 33;								 %Maximum number of TEQ test taps
N =  		512;								 %channel length
Nw = 		2;						   		 %number of TEQ taps
%delta =	28;								 	 %delta = how many values to wait before choosing window
nu = 		32;								 %nu = how many values to select for window
W_opt_pm = zeros(nu,nu);				 %matrix of opt TEQ coefs for power method c
H_eff_pm = zeros(N,nu);
W_opt_ml = zeros(nu,nu);
H_eff_ml = zeros(N,nu);
Conv = zeros(33, 17, 32);					 	  % tap size, interations, different taps
delta = [26;15;16;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28;28];
ssnr = [37.4; 51.9; 49.5; 47.6; 45.5; 43.8; 44.7; 42.9; 42.0; 42.4; 40.5; 39.8; 39.1; 38.6; 38.4; 37.9; 37.7; 37.3; 36.5; 36.6; 38.5; 40.0; 37.1; 36.7; 38.0; 42.7; 34.8; 40.0; 38.6; 38.6; 38.6];

totalInputPower = 14;
AWGNpower = -113;
fs = 2.208e6;         % sampling frequency
M = 50;               % number of DMT block to be transmitted
L = M*N;			     % sequence length
inputImpedance = 100; % Ohm
noisePower = inputImpedance*0.001*fs*10^(AWGNpower/10); % V^2
channelName = ['csaloop','1']
power = inputImpedance*0.001*10^(totalInputPower/10);   % V^2
subsample =1;
inputSignal = sqrt(power)*randn(1,L);

[receivedSignal,h,noise] = ...
      dsl(inputSignal,channelName,noisePower,subsample,10);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

max_power = 0;
h_sqr = zeros(N,1);
for index = 1:N
   h_sqr(index,1) = h(index,1)*h(index, 1);  %look at first vector in h and square 
end;														%each element

for base_index = 1:N-nu+1 
   temp_power = 0;
   for k = 1:nu 										%window is of size "nu"
      temp_power = temp_power + h_sqr(base_index+k-1);
   end;
   if(temp_power > max_power) 					%select window with greatest signal power
      max_power = temp_power;
      %delta = base_index-1;
   end;
   if(temp_power < (.1* max_power) )			%stop if the signal power is now too small
      break;
   end;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

gain = h';
for k = 1:N
    gain(1,k) = gain(1,k) * gain(1,k);
end;
 
B = toeplitz(real(ifft([0 gain 0],N))); 
ifft_gn = ifft(gain, N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculate H_eff for TEQ taps between 2 & 33
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for Nw = 2:MAX_TAPS
%Test out filter for each number of taps

% window function placed at delta+1
g = zeros(N,1);
g(delta(Nw-1,1)+1:delta(Nw-1,1)+nu) = ones(nu,1);
%g(delta+1:delta+nu) = ones(nu,1);

% diagonal signal window matrix
G = diag(g);

% diagonal ISI window matrix
D = diag(1-g);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   H = zeros(N,Nw);
   for col = 1:Nw										%form each column in H matrix using zeros followed by h
   	H(:,col) = [zeros(col-1,1); h(1:N-(col-1),1)];
	end;
   
	%determine wall power
	wall = D * H;
   X = wall' * B * wall;							%X = wall power
   
   %determine window power
	win  = G * H;
	Y = win' * win;									%Y = window power
   
   %determine Z
   Z = inv(X) * Y;

	%initialize l
	l = rand(Nw,1);									%initialize these										

	%initialize DO-WHILE loop...
	z = Z * l;											%step 6.3
	l = z/(z'*z);										%step 6.4
	lambda = l' * Z * l;
	old_lambda = 0;
	count = 0;											%loop iterations
	 
	while abs((old_lambda-lambda)/lambda) > THRESHOLD,     
	  	count = count + 1;
   	z = Z * l;										%step 6.3
   	l = z/(z'*z);									%step 6.4
		if (mod(count,2) == 1)
			old_lambda = lambda;
			lambda = l' * Z * l;
      end;
      Conv(:,count,Nw-1) = [l ; zeros((33-Nw),1)];
	end;

	w_opt = l;											%step 7
   W_opt_pm(1:Nw,Nw-1) = w_opt;
   H_eff_pm(:,Nw-1) = H * w_opt;

	[eig_vectors,eig_values] = eig(Z);
	W_opt_ml(1:Nw,Nw-1) = eig_vectors(:,1);   
	H_eff_ml(:,Nw-1) = H * eig_vectors(:,1);
	   
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%ANALYSIS CALCULATION FOR SNR & ERROR PROBABILITY
H_eff_sqr = zeros(N,nu);
for j = 1:(nu)
	for k = 1:N
  	 	H_eff_sqr(k,j) = H_eff_pm(k,j)*H_eff_pm(k, j); 	%look at first vector in h and square 
	end;																%each element
end;

%eff_power(1,:) has window power
%eff_power(2,:) has wall power

eff_power = zeros(2,nu);										%calculate window power
for j = 1:(nu)															
	for k = (delta(j,1)+1):(delta(j,1)+nu)
      eff_power(1,j) = eff_power(1,j) + H_eff_sqr(k,j);
   end;
end;

for j = 1:(nu)														%calculate left wall power
   for k = 1:(delta(j,1))
      eff_power(2,j) = eff_power(2,j) + H_eff_sqr(k,j);
   end;
end;

for j = 1:(nu)														%calculate right wall power
   for k = (delta(j,1)+nu+1):N
      eff_power(2,j) = eff_power(2,j) + H_eff_sqr(k,j);
   end;
end;

ssnr_ratio = zeros(1,nu);										%shortened signal to noise power ratio
for j = 1:(nu)
   ssnr_ratio(1,j) = 10*log10(eff_power(1,j)/eff_power(2,j));
   %ssnr_ratio(1,j) = eff_power(1,j)/eff_power(2,j);
end;

error_ratio = zeros(1,nu);									   %percentage of single power that is outside window
for j = 1:(nu)
   error_ratio(1,j) = 10*log10(eff_power(2,j)/eff_power(1,j)+eff_power(2,j));
end;

plot(ssnr_ratio, 'c+:'); hold on; plot(ssnr); hold off;
title('Min-ISI TEQ: SSNR of Effective Channel Impulse Response');
xlabel('Tap Number');
ylabel('Amplitude (dB)');
legend('Our tool','Arlsan tool');

